package futils;

import java.io.File;
import java.io.FileInputStream;
import java.util.Vector;


public class DirList {
    String startDir;
    public Vector history = new Vector();
    int totalBytes = 0;
    int totalFiles = 0;

    public static void main(String args[]) {
        DirList dtl = new DirList();
        dtl.printStats();
    }

    DirList() {
        startDir = Ls.getDirName();
        startAtThisDir(startDir);
    }

    public void printStats() {
        System.out.println("Saw " +
                totalFiles +
                " files with a total size of " +
                totalBytes +
                " bytes");
    }

    //-------------------------------------------------------
    // Recursive function that given an anchor directory
    // will walk directory tree
    //
    //-------------------------------------------------------
    public void startAtThisDir(String anchorDir) {
        FileFilter files = new FileFilter();
        DirFilter dirs = new DirFilter();
        File f1 = new File(anchorDir);
        File f2;
        FileInputStream fis;
        int i;
        String[] ls;
        int bytes;

        System.out.println("Selected -> " + anchorDir);
        System.out.println("Files in this Directory: ");

        //-------------------------------------------------------
        // Loop through all the filenames in the current directory
        // and store them in history:
        //-------------------------------------------------------
        for (ls = f1.list(files), i = 0;
             ls != null && i < ls.length; i++) {
            totalFiles++;
            f2 = new File(f1, ls[i]);
            bytes = Futil.available(f2);
            totalBytes += bytes;
            System.out.println(f2 +
                    " has " +
                    bytes + " bytes");
            history.addElement(f2);
        }

        //-------------------------------------------------------
        // This loop recurses on all directory names in
        // the current working directory.
        //-------------------------------------------------------
        for (ls = f1.list(dirs),
                i = 0; ls != null && i < ls.length; i++)
            startAtThisDir(anchorDir + ls[i] + f1.separator);
    }

}



